#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/cms.h>
#include <gdd.h>
#include <memory.h>
#undef ERROR
#undef howmany
#define	ERROR -1

/*
	This routine takes a pointer to an XView coloura array (col)
	a filename with NO extension (filename)
	and the max number of colours allowed to be loaded (max_colours)
*/
int load_colourmap(col,filename,max_colours)
Xv_singlecolor * col;
char * filename;
int max_colours ;
{
        FILE *fp ;
        static char str[120] ;
        int howmany,numread=0 ;
        int r,g,b ;
 
        sprintf(str,"%s.PAL",filename) ; /* Add the PAL suffix to the name specified */
        if ((fp=fopen(str,"r"))==NULL) return(ERROR) ;
 
        if ((fscanf(fp,"%s\n",str)==NULL)||(strncmp(str,"Palette",7)!=0)) return(ERROR) ;
 
        fscanf(fp,"%[^\n]",str) ; /* Scan to end of line */
        fscanf (fp,"%d",&howmany);/* Read the number of colours in the file */
        fgets(str,120,fp) ; /* Skip the text description, and general info lines */
        fgets(str,120,fp) ;

        while ((numread<max_colours)&&(numread<howmany)) {
                fscanf (fp,"%d %d %d -",&r,&g,&b) ; /* Get the (r,g,b) tuples */
                fgets(str,120,fp) ; /* Skip the description, if present */
                col[numread].red=r ;
                col[numread].green=g ;
                col[numread++].blue=b ;
        }

        return (numread) ; /* Return the number of colours ACTUALLY READ */
}
